"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../../ContainerBase/index");
var error_1 = require("../../../utils/error");
var HashContainerBase = /** @class */ (function (_super) {
    __extends(HashContainerBase, _super);
    function HashContainerBase(initBucketNum, hashFunc) {
        if (initBucketNum === void 0) { initBucketNum = HashContainerBase.initBucketNum; }
        if (hashFunc === void 0) { hashFunc = function (x) {
            var hashCode = 0;
            var str = '';
            if (typeof x !== 'string') {
                str = JSON.stringify(x);
            }
            else
                str = x;
            for (var i = 0; i < str.length; i++) {
                var character = str.charCodeAt(i);
                hashCode = ((hashCode << 5) - hashCode) + character;
                hashCode = hashCode & hashCode;
            }
            hashCode ^= (hashCode >>> 16);
            return hashCode;
        }; }
        var _this = _super.call(this) || this;
        if ((initBucketNum & (initBucketNum - 1)) !== 0) {
            throw new error_1.ContainerInitError('initBucketNum must be 2 to the power of n');
        }
        _this.initBucketNum = Math.max(initBucketNum, HashContainerBase.initBucketNum);
        _this.bucketNum = _this.initBucketNum;
        _this.hashFunc = hashFunc;
        return _this;
    }
    HashContainerBase.maxBucketNum = (1 << 30);
    HashContainerBase.initBucketNum = (1 << 4);
    HashContainerBase.sigma = 0.75;
    HashContainerBase.treeifyThreshold = 8;
    HashContainerBase.untreeifyThreshold = 6;
    HashContainerBase.minTreeifySize = 64;
    return HashContainerBase;
}(index_1.Base));
exports.default = HashContainerBase;
