"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DequeIterator = void 0;
var error_1 = require("../../utils/error");
var index_1 = require("../ContainerBase/index");
var checkParams_1 = require("../../utils/checkParams");
var index_2 = __importDefault(require("./Base/index"));
var DequeIterator = /** @class */ (function (_super) {
    __extends(DequeIterator, _super);
    function DequeIterator(index, size, getElementByPos, setElementByPos, iteratorType) {
        if (iteratorType === void 0) { iteratorType = 'normal'; }
        var _this = _super.call(this, index, iteratorType) || this;
        _this.node = index;
        _this.size = size;
        _this.getElementByPos = getElementByPos;
        _this.setElementByPos = setElementByPos;
        return _this;
    }
    Object.defineProperty(DequeIterator.prototype, "pointer", {
        get: function () {
            (0, checkParams_1.checkWithinAccessParams)(this.node, 0, this.size() - 1);
            return this.getElementByPos(this.node);
        },
        set: function (newValue) {
            (0, checkParams_1.checkWithinAccessParams)(this.node, 0, this.size() - 1);
            this.setElementByPos(this.node, newValue);
        },
        enumerable: false,
        configurable: true
    });
    DequeIterator.prototype.pre = function () {
        if (this.iteratorType === 'reverse') {
            if (this.node === this.size() - 1) {
                throw new error_1.RunTimeError('Deque iterator access denied!');
            }
            ++this.node;
        }
        else {
            if (this.node === 0) {
                throw new error_1.RunTimeError('Deque iterator access denied!');
            }
            --this.node;
        }
        return this;
    };
    DequeIterator.prototype.next = function () {
        if (this.iteratorType === 'reverse') {
            if (this.node === -1) {
                throw new error_1.RunTimeError('Deque iterator access denied!');
            }
            --this.node;
        }
        else {
            if (this.node === this.size()) {
                throw new error_1.RunTimeError('Iterator access denied!');
            }
            ++this.node;
        }
        return this;
    };
    DequeIterator.prototype.equals = function (obj) {
        if (obj.constructor.name !== this.constructor.name) {
            throw new TypeError("obj's constructor is not ".concat(this.constructor.name, "!"));
        }
        if (this.iteratorType !== obj.iteratorType) {
            throw new TypeError('iterator type error!');
        }
        // @ts-ignore
        return this.node === obj.node;
    };
    return DequeIterator;
}(index_1.ContainerIterator));
exports.DequeIterator = DequeIterator;
var Deque = /** @class */ (function (_super) {
    __extends(Deque, _super);
    function Deque(container, bucketSize) {
        if (container === void 0) { container = []; }
        if (bucketSize === void 0) { bucketSize = Deque.initBucketSize; }
        var _this = _super.call(this) || this;
        _this.first = 0;
        _this.curFirst = 0;
        _this.last = 0;
        _this.curLast = 0;
        _this.bucketNum = 0;
        _this.map = [];
        var _length;
        if ('size' in container) {
            if (typeof container.size === 'number') {
                _length = container.size;
            }
            else {
                _length = container.size();
            }
        }
        else if ('length' in container) {
            _length = container.length;
        }
        else {
            throw new error_1.ContainerInitError('Can\'t get container\'s size!');
        }
        _this.bucketSize = bucketSize;
        var needSize = _length * Deque.sigma;
        _this.bucketNum = Math.ceil(needSize / _this.bucketSize);
        _this.bucketNum = Math.max(_this.bucketNum, 3);
        for (var i = 0; i < _this.bucketNum; ++i) {
            _this.map.push(new Array(_this.bucketSize));
        }
        var needBucketNum = Math.ceil(_length / _this.bucketSize);
        _this.first = Math.floor(_this.bucketNum / 2) - Math.floor(needBucketNum / 2);
        _this.last = _this.first;
        container.forEach(function (element) { return _this.pushBack(element); });
        return _this;
    }
    Deque.prototype.reAllocate = function (originalSize) {
        var newMap = [];
        var needSize = originalSize * Deque.sigma;
        var newBucketNum = Math.max(Math.ceil(needSize / this.bucketSize), 2);
        for (var i = 0; i < newBucketNum; ++i) {
            newMap.push(new Array(this.bucketSize));
        }
        var needBucketNum = Math.ceil(originalSize / this.bucketSize);
        var newFirst = Math.floor(newBucketNum / 2) - Math.floor(needBucketNum / 2);
        var newLast = newFirst;
        var newCurLast = 0;
        if (this.length) {
            for (var i = 0; i < needBucketNum; ++i) {
                for (var j = 0; j < this.bucketSize; ++j) {
                    newMap[newFirst + i][j] = this.front();
                    this.popFront();
                    if (this.empty()) {
                        newLast = newFirst + i;
                        newCurLast = j;
                        break;
                    }
                }
                if (this.empty())
                    break;
            }
        }
        this.map = newMap;
        this.first = newFirst;
        this.curFirst = 0;
        this.last = newLast;
        this.curLast = newCurLast;
        this.bucketNum = newBucketNum;
        this.length = originalSize;
    };
    Deque.prototype.getElementIndex = function (pos) {
        var curFirstIndex = this.first * this.bucketSize + this.curFirst;
        var curNodeIndex = curFirstIndex + pos;
        var curNodeBucketIndex, curNodePointerIndex;
        if ((curNodeIndex + 1) % this.bucketSize === 0) {
            curNodeBucketIndex = (curNodeIndex + 1) / this.bucketSize - 1;
            curNodePointerIndex = this.bucketSize - 1;
        }
        else {
            curNodeBucketIndex = Math.floor((curNodeIndex + 1) / this.bucketSize);
            curNodePointerIndex = (curNodeIndex + 1) % this.bucketSize - 1;
        }
        return { curNodeBucketIndex: curNodeBucketIndex, curNodePointerIndex: curNodePointerIndex };
    };
    Deque.prototype.getIndex = function (curNodeBucketIndex, curNodePointerIndex) {
        if (curNodeBucketIndex === this.first) {
            return curNodePointerIndex - this.curFirst;
        }
        if (curNodeBucketIndex === this.last) {
            return this.length - (this.curLast - curNodePointerIndex) - 1;
        }
        return (this.bucketSize - this.first) +
            (curNodeBucketIndex - this.first - 1) *
                this.bucketNum + curNodePointerIndex;
    };
    Deque.prototype.clear = function () {
        this.first = this.last = this.curFirst = this.curLast = this.bucketNum = this.length = 0;
        this.reAllocate(this.bucketSize);
        this.length = 0;
    };
    Deque.prototype.front = function () {
        return this.map[this.first][this.curFirst];
    };
    Deque.prototype.back = function () {
        return this.map[this.last][this.curLast];
    };
    Deque.prototype.begin = function () {
        return new DequeIterator(0, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this));
    };
    Deque.prototype.end = function () {
        return new DequeIterator(this.length, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this));
    };
    Deque.prototype.rBegin = function () {
        return new DequeIterator(this.length - 1, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this), 'reverse');
    };
    Deque.prototype.rEnd = function () {
        return new DequeIterator(-1, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this), 'reverse');
    };
    Deque.prototype.pushBack = function (element) {
        if (!this.empty()) {
            if (this.last === this.bucketNum - 1 && this.curLast === this.bucketSize - 1) {
                this.reAllocate(this.length);
            }
            if (this.curLast < this.bucketSize - 1) {
                ++this.curLast;
            }
            else if (this.last < this.bucketNum - 1) {
                ++this.last;
                this.curLast = 0;
            }
        }
        ++this.length;
        this.map[this.last][this.curLast] = element;
    };
    Deque.prototype.popBack = function () {
        if (this.empty())
            return;
        if (this.length !== 1) {
            if (this.curLast > 0) {
                --this.curLast;
            }
            else if (this.first < this.last) {
                --this.last;
                this.curLast = this.bucketSize - 1;
            }
        }
        if (this.length > 0)
            --this.length;
    };
    /**
     * Push the element to the front.
     */
    Deque.prototype.pushFront = function (element) {
        (0, checkParams_1.checkUndefinedParams)(element);
        if (!this.empty()) {
            if (this.first === 0 && this.curFirst === 0) {
                this.reAllocate(this.length);
            }
            if (this.curFirst > 0) {
                --this.curFirst;
            }
            else if (this.first > 0) {
                --this.first;
                this.curFirst = this.bucketSize - 1;
            }
        }
        ++this.length;
        this.map[this.first][this.curFirst] = element;
    };
    /**
     * Remove the first element.
     */
    Deque.prototype.popFront = function () {
        if (this.empty())
            return;
        if (this.size() !== 1) {
            if (this.curFirst < this.bucketSize - 1) {
                ++this.curFirst;
            }
            else if (this.first < this.last) {
                ++this.first;
                this.curFirst = 0;
            }
        }
        if (this.length > 0)
            --this.length;
    };
    Deque.prototype.forEach = function (callback) {
        if (this.empty())
            return;
        var index = 0;
        if (this.first === this.last) {
            for (var i = this.curFirst; i <= this.curLast; ++i) {
                callback(this.map[this.first][i], index++);
            }
            return;
        }
        for (var i = this.curFirst; i < this.bucketSize; ++i) {
            callback(this.map[this.first][i], index++);
        }
        for (var i = this.first + 1; i < this.last; ++i) {
            for (var j = 0; j < this.bucketSize; ++j) {
                callback(this.map[i][j], index++);
            }
        }
        for (var i = 0; i <= this.curLast; ++i) {
            callback(this.map[this.last][i], index++);
        }
    };
    Deque.prototype.getElementByPos = function (pos) {
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.size() - 1);
        var _a = this.getElementIndex(pos), curNodeBucketIndex = _a.curNodeBucketIndex, curNodePointerIndex = _a.curNodePointerIndex;
        return this.map[curNodeBucketIndex][curNodePointerIndex];
    };
    Deque.prototype.setElementByPos = function (pos, element) {
        if (element === undefined || element === null) {
            this.eraseElementByPos(pos);
            return;
        }
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length - 1);
        var _a = this.getElementIndex(pos), curNodeBucketIndex = _a.curNodeBucketIndex, curNodePointerIndex = _a.curNodePointerIndex;
        this.map[curNodeBucketIndex][curNodePointerIndex] = element;
    };
    Deque.prototype.insert = function (pos, element, num) {
        var _this = this;
        if (num === void 0) { num = 1; }
        (0, checkParams_1.checkUndefinedParams)(element);
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length);
        if (pos === 0) {
            while (num--)
                this.pushFront(element);
        }
        else if (pos === this.length) {
            while (num--)
                this.pushBack(element);
        }
        else {
            var arr = [];
            for (var i = pos; i < this.length; ++i) {
                arr.push(this.getElementByPos(i));
            }
            this.cut(pos - 1);
            for (var i = 0; i < num; ++i)
                this.pushBack(element);
            arr.forEach(function (element) { return _this.pushBack(element); });
        }
    };
    /**
     * Remove all elements after the specified position (excluding the specified position).
     */
    Deque.prototype.cut = function (pos) {
        if (pos < 0) {
            this.clear();
            return;
        }
        var _a = this.getElementIndex(pos), curNodeBucketIndex = _a.curNodeBucketIndex, curNodePointerIndex = _a.curNodePointerIndex;
        this.last = curNodeBucketIndex;
        this.curLast = curNodePointerIndex;
        this.length = pos + 1;
    };
    Deque.prototype.eraseElementByPos = function (pos) {
        var _this = this;
        if (pos < 0 || pos > this.length) {
            (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length - 1);
        }
        if (pos === 0)
            this.popFront();
        else if (pos === this.length - 1)
            this.popBack();
        else {
            var arr = [];
            for (var i = pos + 1; i < this.length; ++i) {
                arr.push(this.getElementByPos(i));
            }
            this.cut(pos);
            this.popBack();
            arr.forEach(function (element) { return _this.pushBack(element); });
        }
    };
    Deque.prototype.eraseElementByValue = function (value) {
        if (this.empty())
            return;
        var arr = [];
        this.forEach(function (element) {
            if (element !== value) {
                arr.push(element);
            }
        });
        var _length = arr.length;
        for (var i = 0; i < _length; ++i)
            this.setElementByPos(i, arr[i]);
        this.cut(_length - 1);
    };
    Deque.prototype.eraseElementByIterator = function (iter) {
        // @ts-ignore
        var node = iter.node;
        this.eraseElementByPos(node);
        iter = iter.next();
        return iter;
    };
    Deque.prototype.find = function (element) {
        var _this = this;
        var resIndex = (function () {
            if (_this.first === _this.last) {
                for (var i = _this.curFirst; i <= _this.curLast; ++i) {
                    if (_this.map[_this.first][i] === element) {
                        return _this.getIndex(_this.first, i);
                    }
                }
                return undefined;
            }
            for (var i = _this.curFirst; i < _this.bucketSize; ++i) {
                if (_this.map[_this.first][i] === element) {
                    return _this.getIndex(_this.first, i);
                }
            }
            for (var i = _this.first + 1; i < _this.last; ++i) {
                for (var j = 0; j < _this.bucketSize; ++j) {
                    if (_this.map[i][j] === element) {
                        return _this.getIndex(i, j);
                    }
                }
            }
            for (var i = 0; i <= _this.curLast; ++i) {
                if (_this.map[_this.last][i] === element) {
                    return _this.getIndex(_this.last, i);
                }
            }
            return undefined;
        })();
        if (resIndex === undefined)
            return this.end();
        return new DequeIterator(resIndex, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this));
    };
    Deque.prototype.reverse = function () {
        var l = 0;
        var r = this.length - 1;
        while (l < r) {
            var tmp = this.getElementByPos(l);
            this.setElementByPos(l, this.getElementByPos(r));
            this.setElementByPos(r, tmp);
            ++l;
            --r;
        }
    };
    Deque.prototype.unique = function () {
        if (this.empty())
            return;
        var arr = [];
        var pre = this.front();
        this.forEach(function (element, index) {
            if (index === 0 || element !== pre) {
                arr.push(element);
                pre = element;
            }
        });
        for (var i = 0; i < this.length; ++i) {
            this.setElementByPos(i, arr[i]);
        }
        this.cut(arr.length - 1);
    };
    Deque.prototype.sort = function (cmp) {
        var arr = [];
        this.forEach(function (element) {
            arr.push(element);
        });
        arr.sort(cmp);
        for (var i = 0; i < this.length; ++i)
            this.setElementByPos(i, arr[i]);
    };
    /**
     * Remove as much useless space as possible.
     */
    Deque.prototype.shrinkToFit = function () {
        var _this = this;
        if (this.empty())
            return;
        var arr = [];
        this.forEach(function (element) { return arr.push(element); });
        this.bucketNum = Math.max(Math.ceil(this.length / this.bucketSize), 1);
        this.length = this.first = this.last = this.curFirst = this.curLast = 0;
        this.map = [];
        for (var i = 0; i < this.bucketNum; ++i) {
            this.map.push(new Array(this.bucketSize));
        }
        arr.forEach(function (element) { return _this.pushBack(element); });
    };
    Deque.prototype[Symbol.iterator] = function () {
        return function () {
            var i, i, i, j, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.length === 0)
                            return [2 /*return*/];
                        if (!(this.first === this.last)) return [3 /*break*/, 5];
                        i = this.curFirst;
                        _a.label = 1;
                    case 1:
                        if (!(i <= this.curLast)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.map[this.first][i]];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        ++i;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                    case 5:
                        i = this.curFirst;
                        _a.label = 6;
                    case 6:
                        if (!(i < this.bucketSize)) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.map[this.first][i]];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8:
                        ++i;
                        return [3 /*break*/, 6];
                    case 9:
                        i = this.first + 1;
                        _a.label = 10;
                    case 10:
                        if (!(i < this.last)) return [3 /*break*/, 15];
                        j = 0;
                        _a.label = 11;
                    case 11:
                        if (!(j < this.bucketSize)) return [3 /*break*/, 14];
                        return [4 /*yield*/, this.map[i][j]];
                    case 12:
                        _a.sent();
                        _a.label = 13;
                    case 13:
                        ++j;
                        return [3 /*break*/, 11];
                    case 14:
                        ++i;
                        return [3 /*break*/, 10];
                    case 15:
                        i = 0;
                        _a.label = 16;
                    case 16:
                        if (!(i <= this.curLast)) return [3 /*break*/, 19];
                        return [4 /*yield*/, this.map[this.last][i]];
                    case 17:
                        _a.sent();
                        _a.label = 18;
                    case 18:
                        ++i;
                        return [3 /*break*/, 16];
                    case 19: return [2 /*return*/];
                }
            });
        }.bind(this)();
    };
    Deque.sigma = 3;
    Deque.initBucketSize = (1 << 12);
    return Deque;
}(index_2.default));
exports.default = Deque;
