"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VectorIterator = void 0;
var error_1 = require("../../utils/error");
var index_1 = require("../ContainerBase/index");
var checkParams_1 = require("../../utils/checkParams");
var index_2 = __importDefault(require("./Base/index"));
var VectorIterator = /** @class */ (function (_super) {
    __extends(VectorIterator, _super);
    function VectorIterator(index, size, getElementByPos, setElementByPos, iteratorType) {
        if (iteratorType === void 0) { iteratorType = 'normal'; }
        var _this = _super.call(this, index, iteratorType) || this;
        _this.size = size;
        _this.getElementByPos = getElementByPos;
        _this.setElementByPos = setElementByPos;
        return _this;
    }
    Object.defineProperty(VectorIterator.prototype, "pointer", {
        get: function () {
            (0, checkParams_1.checkWithinAccessParams)(this.node, 0, this.size() - 1);
            return this.getElementByPos(this.node);
        },
        set: function (newValue) {
            (0, checkParams_1.checkWithinAccessParams)(this.node, 0, this.size() - 1);
            this.setElementByPos(this.node, newValue);
        },
        enumerable: false,
        configurable: true
    });
    VectorIterator.prototype.pre = function () {
        if (this.iteratorType === 'reverse') {
            if (this.node === this.size() - 1) {
                throw new error_1.RunTimeError('Deque iterator access denied!');
            }
            ++this.node;
        }
        else {
            if (this.node === 0) {
                throw new error_1.RunTimeError('Deque iterator access denied!');
            }
            --this.node;
        }
        return this;
    };
    VectorIterator.prototype.next = function () {
        if (this.iteratorType === 'reverse') {
            if (this.node === -1) {
                throw new error_1.RunTimeError('Deque iterator access denied!');
            }
            --this.node;
        }
        else {
            if (this.node === this.size()) {
                throw new error_1.RunTimeError('Iterator access denied!');
            }
            ++this.node;
        }
        return this;
    };
    VectorIterator.prototype.equals = function (obj) {
        if (obj.constructor.name !== this.constructor.name) {
            throw new TypeError("obj's constructor is not ".concat(this.constructor.name, "!"));
        }
        if (this.iteratorType !== obj.iteratorType) {
            throw new TypeError('iterator type error!');
        }
        // @ts-ignore
        return this.node === obj.node;
    };
    return VectorIterator;
}(index_1.ContainerIterator));
exports.VectorIterator = VectorIterator;
var Vector = /** @class */ (function (_super) {
    __extends(Vector, _super);
    function Vector(container) {
        if (container === void 0) { container = []; }
        var _this = _super.call(this) || this;
        _this.vector = [];
        container.forEach(function (element) { return _this.pushBack(element); });
        return _this;
    }
    Vector.prototype.clear = function () {
        this.length = 0;
        this.vector.length = 0;
    };
    Vector.prototype.begin = function () {
        return new VectorIterator(0, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this));
    };
    Vector.prototype.end = function () {
        return new VectorIterator(this.length, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this));
    };
    Vector.prototype.rBegin = function () {
        return new VectorIterator(this.length - 1, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this), 'reverse');
    };
    Vector.prototype.rEnd = function () {
        return new VectorIterator(-1, this.size.bind(this), this.getElementByPos.bind(this), this.setElementByPos.bind(this), 'reverse');
    };
    Vector.prototype.front = function () {
        if (this.empty())
            return undefined;
        return this.vector[0];
    };
    Vector.prototype.back = function () {
        if (this.empty())
            return undefined;
        return this.vector[this.length - 1];
    };
    Vector.prototype.forEach = function (callback) {
        this.vector.forEach(callback);
    };
    Vector.prototype.getElementByPos = function (pos) {
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length - 1);
        return this.vector[pos];
    };
    Vector.prototype.eraseElementByPos = function (pos) {
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length - 1);
        for (var i = pos; i < this.length - 1; ++i)
            this.vector[i] = this.vector[i + 1];
        this.popBack();
    };
    Vector.prototype.eraseElementByValue = function (value) {
        var _this = this;
        var newArr = [];
        this.forEach(function (element) {
            if (element !== value)
                newArr.push(element);
        });
        newArr.forEach(function (element, index) {
            _this.vector[index] = element;
        });
        var newLen = newArr.length;
        while (this.length > newLen)
            this.popBack();
    };
    Vector.prototype.eraseElementByIterator = function (iter) {
        // @ts-ignore
        var node = iter.node;
        iter = iter.next();
        this.eraseElementByPos(node);
        return iter;
    };
    Vector.prototype.pushBack = function (element) {
        this.vector.push(element);
        ++this.length;
    };
    Vector.prototype.popBack = function () {
        this.vector.pop();
        if (this.length > 0)
            --this.length;
    };
    Vector.prototype.setElementByPos = function (pos, element) {
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length - 1);
        if (element === undefined || element === null) {
            this.eraseElementByPos(pos);
            return;
        }
        this.vector[pos] = element;
    };
    Vector.prototype.insert = function (pos, element, num) {
        var _a;
        if (num === void 0) { num = 1; }
        (0, checkParams_1.checkUndefinedParams)(element);
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length);
        (_a = this.vector).splice.apply(_a, __spreadArray([pos, 0], __read(new Array(num).fill(element)), false));
        this.length += num;
    };
    Vector.prototype.find = function (element) {
        for (var i = 0; i < this.length; ++i) {
            if (this.vector[i] === element) {
                return new VectorIterator(i, this.size.bind(this), this.getElementByPos.bind(this), this.getElementByPos.bind(this));
            }
        }
        return this.end();
    };
    Vector.prototype.reverse = function () {
        this.vector.reverse();
    };
    Vector.prototype.unique = function () {
        var _this = this;
        var pre;
        var newArr = [];
        this.forEach(function (element, index) {
            if (index === 0 || element !== pre) {
                newArr.push(element);
                pre = element;
            }
        });
        newArr.forEach(function (element, index) {
            _this.vector[index] = element;
        });
        var newLen = newArr.length;
        while (this.length > newLen)
            this.popBack();
    };
    Vector.prototype.sort = function (cmp) {
        this.vector.sort(cmp);
    };
    Vector.prototype[Symbol.iterator] = function () {
        return function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [5 /*yield**/, __values(this.vector)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        }.bind(this)();
    };
    return Vector;
}(index_2.default));
exports.default = Vector;
