"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var error_1 = require("../../../utils/error");
var index_1 = require("../../ContainerBase/index");
var TreeNode_1 = __importDefault(require("./TreeNode"));
var TreeIterator = /** @class */ (function (_super) {
    __extends(TreeIterator, _super);
    function TreeIterator(node, header, iteratorType) {
        var _this = _super.call(this, node, iteratorType) || this;
        _this.header = header;
        return _this;
    }
    TreeIterator.prototype._pre = function () {
        var preNode = this.node;
        if (preNode.color === TreeNode_1.default.TreeNodeColorType.red &&
            preNode.parent.parent === preNode) {
            preNode = preNode.rightChild;
        }
        else if (preNode.leftChild) {
            preNode = preNode.leftChild;
            while (preNode.rightChild) {
                preNode = preNode.rightChild;
            }
        }
        else {
            var pre = preNode.parent;
            while (pre.leftChild === preNode) {
                preNode = pre;
                pre = preNode.parent;
            }
            preNode = pre;
        }
        return preNode;
    };
    TreeIterator.prototype._next = function () {
        var nextNode = this.node;
        if (nextNode.rightChild) {
            nextNode = nextNode.rightChild;
            while (nextNode.leftChild) {
                nextNode = nextNode.leftChild;
            }
        }
        else {
            var pre = nextNode.parent;
            while (pre.rightChild === nextNode) {
                nextNode = pre;
                pre = nextNode.parent;
            }
            if (nextNode.rightChild !== pre) {
                nextNode = pre;
            }
        }
        return nextNode;
    };
    TreeIterator.prototype.pre = function () {
        if (this.iteratorType === 'reverse') {
            if (this.node === this.header.rightChild) {
                throw new error_1.RunTimeError('Tree iterator access denied!');
            }
            this.node = this._next();
        }
        else {
            if (this.node === this.header.leftChild) {
                throw new error_1.RunTimeError('Tree iterator access denied!');
            }
            this.node = this._pre();
        }
        return this;
    };
    TreeIterator.prototype.next = function () {
        if (this.iteratorType === 'reverse') {
            if (this.node === this.header) {
                throw new error_1.RunTimeError('Tree iterator access denied!');
            }
            this.node = this._pre();
        }
        else {
            if (this.node === this.header) {
                throw new error_1.RunTimeError('Tree iterator access denied!');
            }
            this.node = this._next();
        }
        return this;
    };
    TreeIterator.prototype.equals = function (obj) {
        if (obj.constructor.name !== this.constructor.name) {
            throw new TypeError("obj's constructor is not ".concat(this.constructor.name, "!"));
        }
        if (this.iteratorType !== obj.iteratorType) {
            throw new TypeError('iterator type error!');
        }
        // @ts-ignore
        return this.node === obj.node;
    };
    return TreeIterator;
}(index_1.ContainerIterator));
exports.default = TreeIterator;
