"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderedSetIterator = void 0;
var TreeBaseContainer_1 = __importDefault(require("./Base/TreeBaseContainer"));
var checkParams_1 = require("../../utils/checkParams");
var error_1 = require("../../utils/error");
var TreeIterator_1 = __importDefault(require("./Base/TreeIterator"));
var TreeNode_1 = __importDefault(require("./Base/TreeNode"));
var OrderedSetIterator = /** @class */ (function (_super) {
    __extends(OrderedSetIterator, _super);
    function OrderedSetIterator(node, header, iteratorType) {
        if (iteratorType === void 0) { iteratorType = 'normal'; }
        return _super.call(this, node, header, iteratorType) || this;
    }
    Object.defineProperty(OrderedSetIterator.prototype, "pointer", {
        get: function () {
            if (this.node.key === undefined) {
                throw new error_1.RunTimeError('OrderedSet iterator access denied!');
            }
            return this.node.key;
        },
        enumerable: false,
        configurable: true
    });
    return OrderedSetIterator;
}(TreeIterator_1.default));
exports.OrderedSetIterator = OrderedSetIterator;
var OrderedSet = /** @class */ (function (_super) {
    __extends(OrderedSet, _super);
    function OrderedSet(container, cmp) {
        if (container === void 0) { container = []; }
        var _this = _super.call(this, cmp) || this;
        _this.iterationFunc = function (curNode) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!curNode || curNode.key === undefined)
                            return [2 /*return*/];
                        return [5 /*yield**/, __values(this.iterationFunc(curNode.leftChild))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, curNode.key];
                    case 2:
                        _a.sent();
                        return [5 /*yield**/, __values(this.iterationFunc(curNode.rightChild))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        };
        container.forEach(function (element) { return _this.insert(element); });
        _this.iterationFunc = _this.iterationFunc.bind(_this);
        return _this;
    }
    OrderedSet.prototype.begin = function () {
        return new OrderedSetIterator(this.header.leftChild || this.header, this.header);
    };
    OrderedSet.prototype.end = function () {
        return new OrderedSetIterator(this.header, this.header);
    };
    OrderedSet.prototype.rBegin = function () {
        return new OrderedSetIterator(this.header.rightChild || this.header, this.header, 'reverse');
    };
    OrderedSet.prototype.rEnd = function () {
        return new OrderedSetIterator(this.header, this.header, 'reverse');
    };
    OrderedSet.prototype.front = function () {
        var _a;
        return (_a = this.header.leftChild) === null || _a === void 0 ? void 0 : _a.key;
    };
    OrderedSet.prototype.back = function () {
        var _a;
        return (_a = this.header.rightChild) === null || _a === void 0 ? void 0 : _a.key;
    };
    OrderedSet.prototype.forEach = function (callback) {
        var e_1, _a;
        var index = 0;
        try {
            for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
                var element = _c.value;
                callback(element, index++);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    OrderedSet.prototype.getElementByPos = function (pos) {
        var e_2, _a;
        (0, checkParams_1.checkWithinAccessParams)(pos, 0, this.length - 1);
        var index = 0;
        try {
            for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
                var element = _c.value;
                if (index === pos)
                    return element;
                ++index;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    OrderedSet.prototype.eraseElementByIterator = function (iter) {
        // @ts-ignore
        var node = iter.node;
        iter = iter.next();
        this.eraseNode(node);
        return iter;
    };
    /**
     * Inserts element to Set.
     */
    OrderedSet.prototype.insert = function (element) {
        (0, checkParams_1.checkUndefinedParams)(element);
        if (this.empty()) {
            ++this.length;
            this.root.key = element;
            this.root.color = TreeNode_1.default.TreeNodeColorType.black;
            this.header.leftChild = this.root;
            this.header.rightChild = this.root;
            return;
        }
        var curNode = this.findInsertPos(this.root, element);
        if (curNode.key !== undefined && this.cmp(curNode.key, element) === 0) {
            return;
        }
        ++this.length;
        curNode.key = element;
        if (this.header.leftChild === undefined ||
            this.header.leftChild.key === undefined ||
            this.cmp(this.header.leftChild.key, element) > 0) {
            this.header.leftChild = curNode;
        }
        if (this.header.rightChild === undefined ||
            this.header.rightChild.key === undefined ||
            this.cmp(this.header.rightChild.key, element) < 0) {
            this.header.rightChild = curNode;
        }
        this.insertNodeSelfBalance(curNode);
        this.root.color = TreeNode_1.default.TreeNodeColorType.black;
    };
    OrderedSet.prototype.find = function (element) {
        var curNode = this.findElementNode(this.root, element);
        if (curNode !== undefined && curNode.key !== undefined) {
            return new OrderedSetIterator(curNode, this.header);
        }
        return this.end();
    };
    /**
     * @return An iterator to the first element not less than the given key.
     */
    OrderedSet.prototype.lowerBound = function (key) {
        var resNode = this._lowerBound(this.root, key);
        return resNode === undefined
            ? this.end()
            : new OrderedSetIterator(resNode, this.header);
    };
    /**
     * @return An iterator to the first element greater than the given key.
     */
    OrderedSet.prototype.upperBound = function (key) {
        var resNode = this._upperBound(this.root, key);
        return resNode === undefined
            ? this.end()
            : new OrderedSetIterator(resNode, this.header);
    };
    /**
     * @return An iterator to the first element not greater than the given key.
     */
    OrderedSet.prototype.reverseLowerBound = function (key) {
        var resNode = this._reverseLowerBound(this.root, key);
        return resNode === undefined
            ? this.end()
            : new OrderedSetIterator(resNode, this.header);
    };
    /**
     * @return An iterator to the first element less than the given key.
     */
    OrderedSet.prototype.reverseUpperBound = function (key) {
        var resNode = this._reverseUpperBound(this.root, key);
        return resNode === undefined
            ? this.end()
            : new OrderedSetIterator(resNode, this.header);
    };
    /**
     * Union the other Set to self.
     * Waiting for optimization, this is O(mlog(n+m)) algorithm now, but we expect it to be O(mlog(n/m+1)).
     * More information => https://en.wikipedia.org/wiki/Red%E2%80%93black_tree#Set_operations_and_bulk_operations
     */
    OrderedSet.prototype.union = function (other) {
        var _this = this;
        other.forEach(function (element) { return _this.insert(element); });
    };
    OrderedSet.prototype[Symbol.iterator] = function () {
        return this.iterationFunc(this.root);
    };
    return OrderedSet;
}(TreeBaseContainer_1.default));
exports.default = OrderedSet;
