var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Base } from "../ContainerBase/index";
var PriorityQueue = /** @class */ (function (_super) {
    __extends(PriorityQueue, _super);
    function PriorityQueue(container, cmp) {
        if (container === void 0) { container = []; }
        if (cmp === void 0) { cmp = function (x, y) {
            if (x > y)
                return -1;
            if (x < y)
                return 1;
            return 0;
        }; }
        var _this = _super.call(this) || this;
        _this.priorityQueue = [];
        _this.cmp = cmp;
        container.forEach(function (element) { return _this.priorityQueue.push(element); });
        _this.length = _this.priorityQueue.length;
        for (var parent_1 = Math.floor((_this.length - 1) / 2); parent_1 >= 0; --parent_1) {
            var curParent = parent_1;
            var curChild = curParent * 2 + 1;
            while (curChild < _this.length) {
                var leftChild = curChild;
                var rightChild = leftChild + 1;
                var minChild = leftChild;
                if (rightChild < _this.length &&
                    _this.cmp(_this.priorityQueue[leftChild], _this.priorityQueue[rightChild]) > 0) {
                    minChild = rightChild;
                }
                if (_this.cmp(_this.priorityQueue[curParent], _this.priorityQueue[minChild]) <= 0)
                    break;
                _this.swap(curParent, minChild);
                curParent = minChild;
                curChild = curParent * 2 + 1;
            }
        }
        return _this;
    }
    PriorityQueue.prototype.swap = function (x, y) {
        var tmp = this.priorityQueue[x];
        this.priorityQueue[x] = this.priorityQueue[y];
        this.priorityQueue[y] = tmp;
    };
    PriorityQueue.prototype.adjust = function (parent) {
        var leftChild = parent * 2 + 1;
        var rightChild = parent * 2 + 2;
        if (leftChild < this.length &&
            this.cmp(this.priorityQueue[parent], this.priorityQueue[leftChild]) > 0) {
            this.swap(parent, leftChild);
        }
        if (rightChild < this.length &&
            this.cmp(this.priorityQueue[parent], this.priorityQueue[rightChild]) > 0) {
            this.swap(parent, rightChild);
        }
    };
    PriorityQueue.prototype.clear = function () {
        this.length = 0;
        this.priorityQueue.length = 0;
    };
    /**
     * Inserts element and sorts the underlying container.
     */
    PriorityQueue.prototype.push = function (element) {
        this.priorityQueue.push(element);
        ++this.length;
        if (this.length === 1)
            return;
        var curNode = this.length - 1;
        while (curNode > 0) {
            var parent_2 = Math.floor((curNode - 1) / 2);
            if (this.cmp(this.priorityQueue[parent_2], element) <= 0)
                break;
            this.adjust(parent_2);
            curNode = parent_2;
        }
    };
    /**
     * Removes the top element.
     */
    PriorityQueue.prototype.pop = function () {
        if (this.empty())
            return;
        if (this.length === 1) {
            --this.length;
            return;
        }
        var last = this.priorityQueue[this.length - 1];
        --this.length;
        var parent = 0;
        while (parent < this.length) {
            var leftChild = parent * 2 + 1;
            var rightChild = parent * 2 + 2;
            if (leftChild >= this.length)
                break;
            var minChild = leftChild;
            if (rightChild < this.length &&
                this.cmp(this.priorityQueue[leftChild], this.priorityQueue[rightChild]) > 0) {
                minChild = rightChild;
            }
            if (this.cmp(this.priorityQueue[minChild], last) >= 0)
                break;
            this.priorityQueue[parent] = this.priorityQueue[minChild];
            parent = minChild;
        }
        this.priorityQueue[parent] = last;
    };
    /**
     * Accesses the top element.
     */
    PriorityQueue.prototype.top = function () {
        return this.priorityQueue[0];
    };
    return PriorityQueue;
}(Base));
export default PriorityQueue;
