import { ContainerIterator, initContainer } from "../ContainerBase/index";
import SequentialContainer from './Base/index';
export declare class VectorIterator<T> extends ContainerIterator<T, number> {
    private size;
    private getElementByPos;
    private setElementByPos;
    constructor(index: number, size: () => number, getElementByPos: (pos: number) => T, setElementByPos: (pos: number, element: T) => void, iteratorType?: 'normal' | 'reverse');
    get pointer(): T;
    set pointer(newValue: T);
    pre(): this;
    next(): this;
    equals(obj: ContainerIterator<T, number>): boolean;
}
declare class Vector<T> extends SequentialContainer<T, number> {
    private vector;
    constructor(container?: initContainer<T>);
    clear(): void;
    begin(): VectorIterator<T>;
    end(): VectorIterator<T>;
    rBegin(): VectorIterator<T>;
    rEnd(): VectorIterator<T>;
    front(): T | undefined;
    back(): T | undefined;
    forEach(callback: (element: T, index: number) => void): void;
    getElementByPos(pos: number): T;
    eraseElementByPos(pos: number): void;
    eraseElementByValue(value: T): void;
    eraseElementByIterator(iter: ContainerIterator<T, number>): ContainerIterator<T, number>;
    pushBack(element: T): void;
    popBack(): void;
    setElementByPos(pos: number, element: T): void;
    insert(pos: number, element: T, num?: number): void;
    find(element: T): VectorIterator<T>;
    reverse(): void;
    unique(): void;
    sort(cmp?: (x: T, y: T) => number): void;
    [Symbol.iterator](): Generator<T, any, undefined>;
}
export default Vector;
