import { Base } from "../../ContainerBase/index";
import TreeNode from './TreeNode';
declare abstract class TreeBaseContainer<K, V> extends Base {
    protected root: TreeNode<K, V>;
    protected header: TreeNode<K, V>;
    protected cmp: (x: K, y: K) => number;
    constructor(cmp?: (x: K, y: K) => number);
    protected findSubTreeMinNode: (curNode: TreeNode<K, V>) => TreeNode<K, V>;
    protected findSubTreeMaxNode: (curNode: TreeNode<K, V>) => TreeNode<K, V>;
    protected _lowerBound: (curNode: TreeNode<K, V> | undefined, key: K) => TreeNode<K, V> | undefined;
    protected _upperBound: (curNode: TreeNode<K, V> | undefined, key: K) => TreeNode<K, V> | undefined;
    protected _reverseLowerBound: (curNode: TreeNode<K, V> | undefined, key: K) => TreeNode<K, V> | undefined;
    protected _reverseUpperBound: (curNode: TreeNode<K, V> | undefined, key: K) => TreeNode<K, V> | undefined;
    protected eraseNodeSelfBalance(curNode: TreeNode<K, V>): void;
    protected eraseNode(curNode: TreeNode<K, V>): void;
    protected inOrderTraversal: (curNode: TreeNode<K, V> | undefined, callback: (curNode: TreeNode<K, V>) => boolean) => boolean;
    protected findInsertPos: (curNode: TreeNode<K, V>, key: K) => TreeNode<K, V>;
    protected insertNodeSelfBalance(curNode: TreeNode<K, V>): void;
    protected findElementNode: (curNode: TreeNode<K, V> | undefined, key: K) => TreeNode<K, V> | undefined;
    clear(): void;
    eraseElementByPos(pos: number): void;
    /**
     * Removes the elements of the specified key.
     */
    eraseElementByKey(key: K): void;
    /**
     * @return The height of the RB-tree.
     */
    getHeight(): number;
}
export default TreeBaseContainer;
