var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Base } from "../../ContainerBase/index";
import { checkWithinAccessParams } from "../../../utils/checkParams";
import TreeNode from './TreeNode';
var TreeBaseContainer = /** @class */ (function (_super) {
    __extends(TreeBaseContainer, _super);
    function TreeBaseContainer(cmp) {
        if (cmp === void 0) { cmp = function (x, y) {
            if (x < y)
                return -1;
            if (x > y)
                return 1;
            return 0;
        }; }
        var _this = _super.call(this) || this;
        _this.root = new TreeNode();
        _this.header = new TreeNode();
        _this.findSubTreeMinNode = function (curNode) {
            return curNode.leftChild ? _this.findSubTreeMinNode(curNode.leftChild) : curNode;
        };
        _this.findSubTreeMaxNode = function (curNode) {
            return curNode.rightChild ? _this.findSubTreeMaxNode(curNode.rightChild) : curNode;
        };
        _this._lowerBound = function (curNode, key) {
            if (!curNode || curNode.key === undefined)
                return undefined;
            var cmpResult = _this.cmp(curNode.key, key);
            if (cmpResult === 0)
                return curNode;
            if (cmpResult < 0)
                return _this._lowerBound(curNode.rightChild, key);
            var resNode = _this._lowerBound(curNode.leftChild, key);
            if (resNode === undefined)
                return curNode;
            return resNode;
        };
        _this._upperBound = function (curNode, key) {
            if (!curNode || curNode.key === undefined)
                return undefined;
            var cmpResult = _this.cmp(curNode.key, key);
            if (cmpResult <= 0)
                return _this._upperBound(curNode.rightChild, key);
            var resNode = _this._upperBound(curNode.leftChild, key);
            if (resNode === undefined)
                return curNode;
            return resNode;
        };
        _this._reverseLowerBound = function (curNode, key) {
            if (!curNode || curNode.key === undefined)
                return undefined;
            var cmpResult = _this.cmp(curNode.key, key);
            if (cmpResult === 0)
                return curNode;
            if (cmpResult > 0)
                return _this._reverseLowerBound(curNode.leftChild, key);
            var resNode = _this._reverseLowerBound(curNode.rightChild, key);
            if (resNode === undefined)
                return curNode;
            return resNode;
        };
        _this._reverseUpperBound = function (curNode, key) {
            if (!curNode || curNode.key === undefined)
                return undefined;
            var cmpResult = _this.cmp(curNode.key, key);
            if (cmpResult >= 0)
                return _this._reverseUpperBound(curNode.leftChild, key);
            var resNode = _this._reverseUpperBound(curNode.rightChild, key);
            if (resNode === undefined)
                return curNode;
            return resNode;
        };
        _this.inOrderTraversal = function (curNode, callback) {
            if (!curNode || curNode.key === undefined)
                return false;
            var ifReturn = _this.inOrderTraversal(curNode.leftChild, callback);
            if (ifReturn)
                return true;
            if (callback(curNode))
                return true;
            return _this.inOrderTraversal(curNode.rightChild, callback);
        };
        _this.findInsertPos = function (curNode, key) {
            var cmpResult = _this.cmp(key, curNode.key);
            if (cmpResult < 0) {
                if (!curNode.leftChild) {
                    curNode.leftChild = new TreeNode();
                    curNode.leftChild.parent = curNode;
                    curNode.leftChild.brother = curNode.rightChild;
                    if (curNode.rightChild)
                        curNode.rightChild.brother = curNode.leftChild;
                    return curNode.leftChild;
                }
                return _this.findInsertPos(curNode.leftChild, key);
            }
            else if (cmpResult > 0) {
                if (!curNode.rightChild) {
                    curNode.rightChild = new TreeNode();
                    curNode.rightChild.parent = curNode;
                    curNode.rightChild.brother = curNode.leftChild;
                    if (curNode.leftChild)
                        curNode.leftChild.brother = curNode.rightChild;
                    return curNode.rightChild;
                }
                return _this.findInsertPos(curNode.rightChild, key);
            }
            return curNode;
        };
        _this.findElementNode = function (curNode, key) {
            if (!curNode || curNode.key === undefined)
                return undefined;
            var cmpResult = _this.cmp(key, curNode.key);
            if (cmpResult < 0)
                return _this.findElementNode(curNode.leftChild, key);
            else if (cmpResult > 0)
                return _this.findElementNode(curNode.rightChild, key);
            return curNode;
        };
        _this.root.color = TreeNode.TreeNodeColorType.black;
        _this.header.parent = _this.root;
        _this.root.parent = _this.header;
        _this.cmp = cmp;
        return _this;
    }
    TreeBaseContainer.prototype.eraseNodeSelfBalance = function (curNode) {
        var parentNode = curNode.parent;
        if (!parentNode || parentNode === this.header)
            return;
        if (curNode.color === TreeNode.TreeNodeColorType.red) {
            curNode.color = TreeNode.TreeNodeColorType.black;
            return;
        }
        var brotherNode = curNode.brother;
        if (curNode === parentNode.leftChild) {
            if (brotherNode.color === TreeNode.TreeNodeColorType.red) {
                brotherNode.color = TreeNode.TreeNodeColorType.black;
                parentNode.color = TreeNode.TreeNodeColorType.red;
                var newRoot = parentNode.rotateLeft();
                if (this.root === parentNode) {
                    this.root = newRoot;
                    this.header.parent = this.root;
                    this.root.parent = this.header;
                }
                this.eraseNodeSelfBalance(curNode);
            }
            else if (brotherNode.color === TreeNode.TreeNodeColorType.black) {
                if (brotherNode.rightChild &&
                    brotherNode.rightChild.color === TreeNode.TreeNodeColorType.red) {
                    brotherNode.color = parentNode.color;
                    parentNode.color = TreeNode.TreeNodeColorType.black;
                    if (brotherNode.rightChild) {
                        brotherNode.rightChild.color = TreeNode.TreeNodeColorType.black;
                    }
                    var newRoot = parentNode.rotateLeft();
                    if (this.root === parentNode) {
                        this.root = newRoot;
                        this.header.parent = this.root;
                        this.root.parent = this.header;
                    }
                    curNode.color = TreeNode.TreeNodeColorType.black;
                }
                else if ((!brotherNode.rightChild ||
                    brotherNode.rightChild.color === TreeNode.TreeNodeColorType.black) &&
                    brotherNode.leftChild &&
                    brotherNode.leftChild.color === TreeNode.TreeNodeColorType.red) {
                    brotherNode.color = TreeNode.TreeNodeColorType.red;
                    if (brotherNode.leftChild) {
                        brotherNode.leftChild.color = TreeNode.TreeNodeColorType.black;
                    }
                    var newRoot = brotherNode.rotateRight();
                    if (this.root === brotherNode) {
                        this.root = newRoot;
                        this.header.parent = this.root;
                        this.root.parent = this.header;
                    }
                    this.eraseNodeSelfBalance(curNode);
                }
                else if ((!brotherNode.leftChild ||
                    brotherNode.leftChild.color === TreeNode.TreeNodeColorType.black) && (!brotherNode.rightChild ||
                    brotherNode.rightChild.color === TreeNode.TreeNodeColorType.black)) {
                    brotherNode.color = TreeNode.TreeNodeColorType.red;
                    this.eraseNodeSelfBalance(parentNode);
                }
            }
        }
        else if (curNode === parentNode.rightChild) {
            if (brotherNode.color === TreeNode.TreeNodeColorType.red) {
                brotherNode.color = TreeNode.TreeNodeColorType.black;
                parentNode.color = TreeNode.TreeNodeColorType.red;
                var newRoot = parentNode.rotateRight();
                if (this.root === parentNode) {
                    this.root = newRoot;
                    this.header.parent = this.root;
                    this.root.parent = this.header;
                }
                this.eraseNodeSelfBalance(curNode);
            }
            else if (brotherNode.color === TreeNode.TreeNodeColorType.black) {
                if (brotherNode.leftChild &&
                    brotherNode.leftChild.color === TreeNode.TreeNodeColorType.red) {
                    brotherNode.color = parentNode.color;
                    parentNode.color = TreeNode.TreeNodeColorType.black;
                    if (brotherNode.leftChild)
                        brotherNode.leftChild.color = TreeNode.TreeNodeColorType.black;
                    var newRoot = parentNode.rotateRight();
                    if (this.root === parentNode) {
                        this.root = newRoot;
                        this.header.parent = this.root;
                        this.root.parent = this.header;
                    }
                    curNode.color = TreeNode.TreeNodeColorType.black;
                }
                else if ((!brotherNode.leftChild ||
                    brotherNode.leftChild.color === TreeNode.TreeNodeColorType.black) &&
                    brotherNode.rightChild &&
                    brotherNode.rightChild.color === TreeNode.TreeNodeColorType.red) {
                    brotherNode.color = TreeNode.TreeNodeColorType.red;
                    if (brotherNode.rightChild) {
                        brotherNode.rightChild.color = TreeNode.TreeNodeColorType.black;
                    }
                    var newRoot = brotherNode.rotateLeft();
                    if (this.root === brotherNode) {
                        this.root = newRoot;
                        this.header.parent = this.root;
                        this.root.parent = this.header;
                    }
                    this.eraseNodeSelfBalance(curNode);
                }
                else if ((!brotherNode.leftChild ||
                    brotherNode.leftChild.color === TreeNode.TreeNodeColorType.black) && (!brotherNode.rightChild ||
                    brotherNode.rightChild.color === TreeNode.TreeNodeColorType.black)) {
                    brotherNode.color = TreeNode.TreeNodeColorType.red;
                    this.eraseNodeSelfBalance(parentNode);
                }
            }
        }
    };
    TreeBaseContainer.prototype.eraseNode = function (curNode) {
        var swapNode = curNode;
        while (swapNode.leftChild || swapNode.rightChild) {
            if (swapNode.rightChild) {
                swapNode = this.findSubTreeMinNode(swapNode.rightChild);
                var tmpKey = curNode.key;
                curNode.key = swapNode.key;
                swapNode.key = tmpKey;
                var tmpValue = curNode.value;
                curNode.value = swapNode.value;
                swapNode.value = tmpValue;
                curNode = swapNode;
            }
            if (swapNode.leftChild) {
                swapNode = this.findSubTreeMaxNode(swapNode.leftChild);
                var tmpKey = curNode.key;
                curNode.key = swapNode.key;
                swapNode.key = tmpKey;
                var tmpValue = curNode.value;
                curNode.value = swapNode.value;
                swapNode.value = tmpValue;
                curNode = swapNode;
            }
        }
        if (this.header.leftChild &&
            this.header.leftChild.key !== undefined &&
            this.cmp(this.header.leftChild.key, swapNode.key) === 0) {
            if (this.header.leftChild !== this.root) {
                this.header.leftChild = this.header.leftChild.parent;
            }
            else if (this.header.leftChild.rightChild) {
                this.header.leftChild = this.header.leftChild.rightChild;
            }
            else {
                this.header.leftChild = undefined;
            }
        }
        if (this.header.rightChild &&
            this.header.rightChild.key !== undefined &&
            this.cmp(this.header.rightChild.key, swapNode.key) === 0) {
            if (this.header.rightChild !== this.root) {
                this.header.rightChild = this.header.rightChild.parent;
            }
            else if (this.header.rightChild.leftChild) {
                this.header.rightChild = this.header.rightChild.leftChild;
            }
            else {
                this.header.rightChild = undefined;
            }
        }
        this.eraseNodeSelfBalance(swapNode);
        if (swapNode)
            swapNode.remove();
        --this.length;
        this.root.color = TreeNode.TreeNodeColorType.black;
    };
    TreeBaseContainer.prototype.insertNodeSelfBalance = function (curNode) {
        var parentNode = curNode.parent;
        if (!parentNode || parentNode === this.header)
            return;
        if (parentNode.color === TreeNode.TreeNodeColorType.black)
            return;
        if (parentNode.color === TreeNode.TreeNodeColorType.red) {
            var uncleNode = parentNode.brother;
            var grandParent = parentNode.parent;
            if (uncleNode && uncleNode.color === TreeNode.TreeNodeColorType.red) {
                uncleNode.color = parentNode.color = TreeNode.TreeNodeColorType.black;
                grandParent.color = TreeNode.TreeNodeColorType.red;
                this.insertNodeSelfBalance(grandParent);
            }
            else if (!uncleNode || uncleNode.color === TreeNode.TreeNodeColorType.black) {
                if (parentNode === grandParent.leftChild) {
                    if (curNode === parentNode.leftChild) {
                        parentNode.color = TreeNode.TreeNodeColorType.black;
                        grandParent.color = TreeNode.TreeNodeColorType.red;
                        var newRoot = grandParent.rotateRight();
                        if (grandParent === this.root) {
                            this.root = newRoot;
                            this.header.parent = this.root;
                            this.root.parent = this.header;
                        }
                    }
                    else if (curNode === parentNode.rightChild) {
                        var newRoot = parentNode.rotateLeft();
                        if (parentNode === this.root) {
                            this.root = newRoot;
                            this.header.parent = this.root;
                            this.root.parent = this.header;
                        }
                        this.insertNodeSelfBalance(parentNode);
                    }
                }
                else if (parentNode === grandParent.rightChild) {
                    if (curNode === parentNode.leftChild) {
                        var newRoot = parentNode.rotateRight();
                        if (parentNode === this.root) {
                            this.root = newRoot;
                            this.header.parent = this.root;
                            this.root.parent = this.header;
                        }
                        this.insertNodeSelfBalance(parentNode);
                    }
                    else if (curNode === parentNode.rightChild) {
                        parentNode.color = TreeNode.TreeNodeColorType.black;
                        grandParent.color = TreeNode.TreeNodeColorType.red;
                        var newRoot = grandParent.rotateLeft();
                        if (grandParent === this.root) {
                            this.root = newRoot;
                            this.header.parent = this.root;
                            this.root.parent = this.header;
                        }
                    }
                }
            }
        }
    };
    TreeBaseContainer.prototype.clear = function () {
        this.length = 0;
        this.root.key = this.root.value = undefined;
        this.root.leftChild = this.root.rightChild = this.root.brother = undefined;
        this.header.leftChild = this.header.rightChild = undefined;
    };
    TreeBaseContainer.prototype.eraseElementByPos = function (pos) {
        var _this = this;
        checkWithinAccessParams(pos, 0, this.length - 1);
        var index = 0;
        this.inOrderTraversal(this.root, function (curNode) {
            if (pos === index) {
                _this.eraseNode(curNode);
                return true;
            }
            ++index;
            return false;
        });
    };
    /**
     * Removes the elements of the specified key.
     */
    TreeBaseContainer.prototype.eraseElementByKey = function (key) {
        if (this.empty())
            return;
        var curNode = this.findElementNode(this.root, key);
        if (curNode === undefined ||
            curNode.key === undefined ||
            this.cmp(curNode.key, key) !== 0)
            return;
        this.eraseNode(curNode);
    };
    /**
     * @return The height of the RB-tree.
     */
    TreeBaseContainer.prototype.getHeight = function () {
        if (this.empty())
            return 0;
        var traversal = function (curNode) {
            if (!curNode)
                return 1;
            return Math.max(traversal(curNode.leftChild), traversal(curNode.rightChild)) + 1;
        };
        return traversal(this.root);
    };
    return TreeBaseContainer;
}(Base));
export default TreeBaseContainer;
