var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { RunTimeError } from "../../utils/error";
import { checkUndefinedParams, checkWithinAccessParams } from "../../utils/checkParams";
import TreeBaseContainer from './Base/TreeBaseContainer';
import TreeIterator from './Base/TreeIterator';
import TreeNode from './Base/TreeNode';
var OrderedMapIterator = /** @class */ (function (_super) {
    __extends(OrderedMapIterator, _super);
    function OrderedMapIterator(node, header, iteratorType) {
        if (iteratorType === void 0) { iteratorType = 'normal'; }
        return _super.call(this, node, header, iteratorType) || this;
    }
    Object.defineProperty(OrderedMapIterator.prototype, "pointer", {
        get: function () {
            var _this = this;
            if (this.node.key === undefined) {
                throw new RunTimeError('OrderedMap iterator access denied');
            }
            return new Proxy([this.node.key, this.node.value], {
                get: function (_, prop) {
                    var index = Number(prop);
                    if (Number.isNaN(index)) {
                        throw new TypeError('prop must be number');
                    }
                    checkWithinAccessParams(index, 0, 1);
                    return index === 0 ? _this.node.key : _this.node.value;
                },
                set: function (_, prop, newValue) {
                    var index = Number(prop);
                    if (Number.isNaN(index)) {
                        throw new TypeError('prop must be number');
                    }
                    checkWithinAccessParams(index, 1, 1);
                    _this.node.value = newValue;
                    return true;
                }
            });
        },
        enumerable: false,
        configurable: true
    });
    return OrderedMapIterator;
}(TreeIterator));
export { OrderedMapIterator };
var OrderedMap = /** @class */ (function (_super) {
    __extends(OrderedMap, _super);
    function OrderedMap(container, cmp) {
        if (container === void 0) { container = []; }
        var _this = _super.call(this, cmp) || this;
        _this.iterationFunc = function (curNode) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!curNode || curNode.key === undefined || curNode.value === undefined)
                            return [2 /*return*/];
                        return [5 /*yield**/, __values(this.iterationFunc(curNode.leftChild))];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, [curNode.key, curNode.value]];
                    case 2:
                        _a.sent();
                        return [5 /*yield**/, __values(this.iterationFunc(curNode.rightChild))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        };
        _this.iterationFunc = _this.iterationFunc.bind(_this);
        container.forEach(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            return _this.setElement(key, value);
        });
        return _this;
    }
    /**
     * @return Iterator pointing to the begin element.
     */
    OrderedMap.prototype.begin = function () {
        return new OrderedMapIterator(this.header.leftChild || this.header, this.header);
    };
    /**
     * @return Iterator pointing to the super end like c++.
     */
    OrderedMap.prototype.end = function () {
        return new OrderedMapIterator(this.header, this.header);
    };
    /**
     * @return Iterator pointing to the end element.
     */
    OrderedMap.prototype.rBegin = function () {
        return new OrderedMapIterator(this.header.rightChild || this.header, this.header, 'reverse');
    };
    /**
     * @return Iterator pointing to the super begin like c++.
     */
    OrderedMap.prototype.rEnd = function () {
        return new OrderedMapIterator(this.header, this.header, 'reverse');
    };
    /**
     * @return The first element.
     */
    OrderedMap.prototype.front = function () {
        if (this.empty())
            return undefined;
        var minNode = this.header.leftChild;
        return [minNode.key, minNode.value];
    };
    /**
     * @return The last element.
     */
    OrderedMap.prototype.back = function () {
        if (this.empty())
            return undefined;
        var maxNode = this.header.rightChild;
        return [maxNode.key, maxNode.value];
    };
    /**
     * @param callback callback function, it's first param is an array which type is [key, value].
     */
    OrderedMap.prototype.forEach = function (callback) {
        var e_1, _a;
        var index = 0;
        try {
            for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
                var pair = _c.value;
                callback(pair, index++);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @return An iterator to the first element not less than the given key.
     */
    OrderedMap.prototype.lowerBound = function (key) {
        var resNode = this._lowerBound(this.root, key);
        return resNode === undefined ? this.end() : new OrderedMapIterator(resNode, this.header);
    };
    /**
     * @return An iterator to the first element greater than the given key.
     */
    OrderedMap.prototype.upperBound = function (key) {
        var resNode = this._upperBound(this.root, key);
        return resNode === undefined ? this.end() : new OrderedMapIterator(resNode, this.header);
    };
    /**
     * @return An iterator to the first element not greater than the given key.
     */
    OrderedMap.prototype.reverseLowerBound = function (key) {
        var resNode = this._reverseLowerBound(this.root, key);
        return resNode === undefined ? this.end() : new OrderedMapIterator(resNode, this.header);
    };
    /**
     * @return An iterator to the first element less than the given key.
     */
    OrderedMap.prototype.reverseUpperBound = function (key) {
        var resNode = this._reverseUpperBound(this.root, key);
        return resNode === undefined ? this.end() : new OrderedMapIterator(resNode, this.header);
    };
    /**
     * Insert a new key-value pair or set value by key.
     */
    OrderedMap.prototype.setElement = function (key, value) {
        checkUndefinedParams(key);
        if (value === null || value === undefined) {
            this.eraseElementByKey(key);
            return;
        }
        if (this.empty()) {
            ++this.length;
            this.root.key = key;
            this.root.value = value;
            this.root.color = TreeNode.TreeNodeColorType.black;
            this.header.leftChild = this.root;
            this.header.rightChild = this.root;
            return;
        }
        var curNode = this.findInsertPos(this.root, key);
        if (curNode.key !== undefined && this.cmp(curNode.key, key) === 0) {
            curNode.value = value;
            return;
        }
        ++this.length;
        curNode.key = key;
        curNode.value = value;
        if (this.header.leftChild === undefined ||
            this.header.leftChild.key === undefined ||
            this.cmp(this.header.leftChild.key, key) > 0) {
            this.header.leftChild = curNode;
        }
        if (this.header.rightChild === undefined ||
            this.header.rightChild.key === undefined ||
            this.cmp(this.header.rightChild.key, key) < 0) {
            this.header.rightChild = curNode;
        }
        this.insertNodeSelfBalance(curNode);
        this.root.color = TreeNode.TreeNodeColorType.black;
    };
    /**
     * @param key The key you want to find.
     * @return Iterator pointing to the element if found, or super end if not found.
     */
    OrderedMap.prototype.find = function (key) {
        var curNode = this.findElementNode(this.root, key);
        if (curNode !== undefined && curNode.key !== undefined) {
            return new OrderedMapIterator(curNode, this.header);
        }
        return this.end();
    };
    /**
     * Gets the value of the element of the specified key.
     */
    OrderedMap.prototype.getElementByKey = function (key) {
        var curNode = this.findElementNode(this.root, key);
        if ((curNode === null || curNode === void 0 ? void 0 : curNode.value) === undefined)
            return undefined;
        return curNode.value;
    };
    OrderedMap.prototype.getElementByPos = function (pos) {
        var e_2, _a;
        checkWithinAccessParams(pos, 0, this.length - 1);
        var index = 0;
        try {
            for (var _b = __values(this), _c = _b.next(); !_c.done; _c = _b.next()) {
                var pair = _c.value;
                if (index === pos)
                    return pair;
                ++index;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    /**
     * @return An iterator point to the next iterator.
     * Removes element by iterator.
     */
    OrderedMap.prototype.eraseElementByIterator = function (iter) {
        // @ts-ignore
        var node = iter.node;
        iter = iter.next();
        this.eraseNode(node);
        return iter;
    };
    /**
     * Union the other Set to self.
     * waiting for optimization, this is O(mlog(n+m)) algorithm now, but we expect it to be O(mlog(n/m+1)).
     * More information => https://en.wikipedia.org/wiki/Red%E2%80%93black_tree#Set_operations_and_bulk_operations
     */
    OrderedMap.prototype.union = function (other) {
        var _this = this;
        other.forEach(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            return _this.setElement(key, value);
        });
    };
    /**
     * Using for 'for...of' syntax like Array.
     */
    OrderedMap.prototype[Symbol.iterator] = function () {
        return this.iterationFunc(this.root);
    };
    return OrderedMap;
}(TreeBaseContainer));
export default OrderedMap;
